import { EnrichCompletionHandler } from './hybrid';
import { PrometheusClient, PrometheusConfig } from '../client/prometheus';
import { CompletionContext, CompletionResult } from '@codemirror/autocomplete';
export { EnrichCompletionHandler, ContextKind } from './hybrid';
export interface CompleteStrategy {
    promQL(context: CompletionContext): Promise<CompletionResult> | CompletionResult | null;
}
export interface CompleteConfiguration {
    remote?: PrometheusConfig | PrometheusClient;
    maxMetricsMetadata?: number;
    enricher?: EnrichCompletionHandler;
    completeStrategy?: CompleteStrategy;
}
export declare function newCompleteStrategy(conf?: CompleteConfiguration): CompleteStrategy;
